package czerwony.kapturek.jbspell;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import com.borland.jbcl.layout.*;
import javax.swing.*;

public class MessageBox extends JDialog
{
    private JLabel      labelMessage = new JLabel();
    private JButton     buttonOk = new JButton("OK");
    private JCheckBox   checkNotAgain = new JCheckBox("Don't show this message again");

    private boolean     notAgain;
    private String      message;

    private MessageBox(JFrame parent, String message, boolean notAgain)
    {
        super(parent, true);
        this.notAgain = notAgain;
        this.message = message;
        initUi();
        initListeners();
    }


    private void initUi()
    {
        setTitle("Spell Checker");
        Container panel = getContentPane();
        panel.setLayout(new GridBagLayout());
        labelMessage.setText("<HTML><b>" + message);
        labelMessage.setHorizontalAlignment(JLabel.CENTER);
        panel.add(labelMessage,
                    new GridBagConstraints(0, 0, 1, 1, 1, 1,
                                           GridBagConstraints.CENTER,
                                           GridBagConstraints.HORIZONTAL,
                                           new Insets(10,10,30,10),
                                           0, 20));
        if (notAgain)
            panel.add(checkNotAgain,
                    new GridBagConstraints(0, 1, 1, 1, 1, 0,
                                           GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(0,10,0,10),
                                           0, 0));
        panel.add(buttonOk,
                    new GridBagConstraints(0, 2, 1, 1, 1, 0,
                                           GridBagConstraints.CENTER,
                                           GridBagConstraints.NONE,
                                           new Insets(0,0,10,0),
                                           0, 0));
        pack();
    }


    private void initListeners()
    {
        addKeyListener(new KeyAdapter()
            {
                public void keyPressed(KeyEvent ev)
                {
                    if (ev.getKeyCode() == KeyEvent.VK_ESCAPE)
                    {
                        checkNotAgain.setSelected(false);
                        dispose();
                    }
                }
            });

        buttonOk.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent ev)
                {
                    dispose();
                }
            });
    }


    public static boolean showMessage(JFrame parent, String message, boolean notAgain)
    {
        MessageBox mb = new MessageBox(parent, message, notAgain);
        Rectangle r = mb.getBounds();
        Rectangle p = parent.getBounds();
        mb.setBounds((p.width - r.width) / 2 + p.x,
                     (p.height - r.height) / 2 + p.y,
                     r.width, r.height);
        mb.setVisible(true);
        return mb.checkNotAgain.isSelected();
    }
}